import axios from 'axios';
import { JSDOM } from 'jsdom';
import { printError } from '../utils/messages.js';
const getCSRFToken = async (route, csrf_action, SessionId) => {
    return await axios
        .get(route, SessionId
        ? {
            baseURL: 'https://solve.edu.pl/',
            headers: {
                Cookie: `PHPSESSID=${SessionId};`,
            },
        }
        : {
            baseURL: 'https://solve.edu.pl/',
        })
        .then((res) => {
        var _a;
        const dom = new JSDOM(res.data);
        const token = (_a = dom.window.document.querySelector(`input[name='csrf_action'][value='${csrf_action}']+input[name='csrf_token']`)) === null || _a === void 0 ? void 0 : _a.getAttribute('value');
        if (!token) {
            printError('CSRF token could not be retrieved!');
            return '';
        }
        return token;
    })
        .catch((error) => {
        printError(error.message);
        return null;
    });
};
export default getCSRFToken;
//# sourceMappingURL=getCSRFToken.js.map