import axios from 'axios';
import { createReadStream } from 'fs';
import FormData from 'form-data';
import getCSRFToken from '../utils/getCSRFToken.js';
import { taskSubmit, contestPage } from '../lib/routes.js';
const postSolveData = async (SessionId, route, data) => {
    return await axios
        .post(route, data, SessionId
        ? {
            baseURL: 'https://solve.edu.pl/',
            headers: Object.assign(Object.assign({}, data.getHeaders()), { Cookie: `PHPSESSID=${SessionId};` }),
        }
        : {
            baseURL: 'https://solve.edu.pl/',
        })
        .then((res) => res)
        .catch((error) => {
        throw new Error('Error: ' + error.message);
    });
};
export const createTaskSubmitData = async (SessionId, id, filePath, lang = 'cpp') => {
    const formData = new FormData();
    const csrfAction = 'tasks_submit';
    const fileLabel = 'tasks_submit[solution_file]';
    const csrfToken = await getCSRFToken(taskSubmit + id, csrfAction, SessionId);
    formData.append('csrf_action', csrfAction);
    formData.append('csrf_token', csrfToken);
    formData.append('tasks_submit[solution_lang]', lang);
    formData.append(fileLabel, createReadStream(filePath, 'utf8'));
    formData.append('submit_tasks_submit', 'Wyślij');
    return formData;
};
export const createSubmitData = async (SessionId, id, problemShortName, filePath) => {
    const formData = new FormData();
    const csrfAction = 'contest_submit';
    const csrfToken = await getCSRFToken(contestPage + id, csrfAction, SessionId);
    formData.append('csrf_action', csrfAction);
    formData.append('csrf_token', csrfToken);
    formData.append('contest_submit[problem]', problemShortName);
    formData.append('contest_submit[solution_file]', createReadStream(filePath, 'utf8'));
    return formData;
};
export default postSolveData;
//# sourceMappingURL=postSolveData.js.map